var pathSymbol = Symbol('Object path');
var ProxyPolyfill = require('es6-proxy-polyfill');
function createProxy(path) {
    if (path === void 0) { path = []; }
    var _a;
    var proxy = new ProxyPolyfill((_a = {}, _a[pathSymbol] = path, _a), {
        get: function (target, key) {
            if (key === pathSymbol) {
                return target[pathSymbol];
            }
            if (key === '_path') {
                return path;
            }
            if (key === '_pathString') {
                return path.join('.');
            }
            if (key === '_pathUrl') {
                return path.join('/');
            }
            if (key === '_name') {
                return path[path.length - 1];
            }
            var keys = [];
            if (typeof key === 'string') {
                keys = key.split('.');
            }
            return createProxy((path || []).concat(keys.map(function (key) {
                var newKey = key;
                var intKey = parseInt(key.toString(), 10);
                if (key === intKey.toString()) {
                    newKey = intKey;
                }
                return newKey;
            })));
        }
    });
    return proxy;
}
function get(object, proxy, defaultValue) {
    if (defaultValue === void 0) { defaultValue = undefined; }
    return proxy._path.reduce(function (o, key) {
        var v = o && o[key];
        return v != null ? v : defaultValue;
    }, object);
}
function set(object, proxy, value) {
    proxy._path.reduce(function (o, key, index, keys) {
        if (index < keys.length - 1) {
            o[key] = o[key] != null ? o[key] : (typeof keys[index + 1] === 'number' ? [] : {});
            return o[key];
        }
        o[key] = value;
    }, object);
}

export { createProxy, get, set };
//# sourceMappingURL=ts-object-path.es5.js.map
